diff --git a/config.h.in b/config.h.in
index d1c8737..f154238 100644
--- a/config.h.in
+++ b/config.h.in
@@ -114,6 +114,9 @@
 /* Define to the one symbol short name of this package. */
 #undef PACKAGE_TARNAME
 
+/* Define to the home page for this package. */
+#undef PACKAGE_URL
+
 /* Define to the version of this package. */
 #undef PACKAGE_VERSION
 
diff --git a/debian/changelog b/debian/changelog
index 680064a..c6d0cae 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,18 @@
+dmucs (0.6.1-2.2) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Packaging changes:
+    - Remove deprecated dpatch and upgrade to packaging format "3.0 quilt".
+    - Switch from cddbs to debhelper 9 to enable hardened build flags.
+    - Update to Standards-Version to 3.9.3
+  * Patches:
+    - Number 10: New. Move in-line changes to original sources here.
+    - Number 20: Update with "quilt refresh" to make it apply cleanly.
+    - Number 20: New. Fix for hardened build flags.
+  * Fix copyright-refers-to-symlink-license (Lintian).
+
+ -- Jari Aalto <jari.aalto@cante.net>  Thu, 12 Apr 2012 16:04:32 +0300
+
 dmucs (0.6.1-2.1) unstable; urgency=low
 
   * Non-maintainer upload to fix release goal.
diff --git a/debian/compat b/debian/compat
index 7ed6ff8..ec63514 100644
--- a/debian/compat
+++ b/debian/compat
@@ -1 +1 @@
-5
+9
diff --git a/debian/control b/debian/control
index 1cd4e4f..2280046 100644
--- a/debian/control
+++ b/debian/control
@@ -2,8 +2,8 @@ Source: dmucs
 Section: devel
 Priority: extra
 Maintainer: Sam Clegg <samo@debian.org>
-Build-Depends: cdbs, debhelper (>= 5), autotools-dev, dpatch
-Standards-Version: 3.8.0
+Build-Depends: debhelper (>= 9), autotools-dev
+Standards-Version: 3.9.3
 
 Package: dmucs
 Architecture: any
diff --git a/debian/copyright b/debian/copyright
index 493170b..abc7801 100644
--- a/debian/copyright
+++ b/debian/copyright
@@ -24,7 +24,7 @@ Copyright:
    Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
 
 On Debian GNU/Linux systems, the complete text of the GNU General
-Public License can be found in `/usr/share/common-licenses/GPL'.
+Public License can be found in `/usr/share/common-licenses/GPL-2'.
 
 The files in the COSMIC are Copyright (C) 1999-2005 Charles E. Campbell, Jr
 and distributed under the following license (the following text is from
diff --git a/debian/patches/series b/debian/patches/series
new file mode 100644
index 0000000..a59356d
--- /dev/null
+++ b/debian/patches/series
@@ -0,0 +1,3 @@
+10-debian-local-changes.patch
+20-fix-FTBFS-vsprintf.patch
+30-include.patch
diff --git a/debian/rules b/debian/rules
index dffa562..abc1eb5 100755
--- a/debian/rules
+++ b/debian/rules
@@ -1,11 +1,15 @@
 #!/usr/bin/make -f
-  
-include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/autotools.mk
-include /usr/share/cdbs/1/rules/dpatch.mk
 
-install/dmucs::
-	cp remhost addhost
+export DEB_BUILD_MAINT_OPTIONS	= hardening=+all
+export DEB_CFLAGS_MAINT_APPEND	= -Wall
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-clean::
+override_dh_auto_install:
+	cp -a remhost addhost
+
+override_dh_clean:
+	dh_clean
 	rm -f addhost config.log
+
+%:
+	dh $@
diff --git a/debian/source/format b/debian/source/format
new file mode 100644
index 0000000..163aaf8
--- /dev/null
+++ b/debian/source/format
@@ -0,0 +1 @@
+3.0 (quilt)
diff --git a/dmucs_db.cc b/dmucs_db.cc
index 34baaf6..e0990f6 100644
--- a/dmucs_db.cc
+++ b/dmucs_db.cc
@@ -61,9 +61,9 @@ DmucsDb::getInstance()
 
 
 void
-DmucsDb::assignCpuToClient(unsigned int clientIp,
-                           DmucsDprop dprop,
-                           intptr_t sock)
+DmucsDb::assignCpuToClient(const unsigned int clientIp,
+                           const DmucsDprop dprop,
+                           const unsigned int sock)
 {
     MutexMonitor m(&mutex_);
 
@@ -74,7 +74,7 @@ DmucsDb::assignCpuToClient(unsigned int clientIp,
 
 
 void
-DmucsDb::releaseCpu(intptr_t sock)
+DmucsDb::releaseCpu(const unsigned int sock)
 {
     /* Get the dprop so that we can release the cpu back into the
        correct sub-db in the DmucsDb. */
@@ -145,8 +145,8 @@ DmucsDpropDb::getBestAvailCpu()
 
 
 void
-DmucsDpropDb::assignCpuToClient(unsigned int hostIp,
-                                unsigned int sock)
+DmucsDpropDb::assignCpuToClient(const unsigned int hostIp,
+                                const unsigned int sock)
 {
     struct in_addr t2;
     t2.s_addr = hostIp;
@@ -164,13 +164,13 @@ DmucsDpropDb::assignCpuToClient(unsigned int hostIp,
 
 
 void
-DmucsDpropDb::releaseCpu(intptr_t sock)
+DmucsDpropDb::releaseCpu(const unsigned int sock)
 {
-    DMUCS_DEBUG((stderr, "releaseCpu for socket 0x%tx\n", sock));
+    DMUCS_DEBUG((stderr, "releaseCpu for socket 0x%x\n", sock));
 
     dmucs_assigned_cpus_iter_t itr = assignedCpus_.find(sock);
     if (itr == assignedCpus_.end()) {
-	DMUCS_DEBUG((stderr, "No cpu found in assignedCpus for sock 0x%tx\n",
+	DMUCS_DEBUG((stderr, "No cpu found in assignedCpus for sock 0x%x\n",
 		     sock));
 	return;
     }
diff --git a/dmucs_db.h b/dmucs_db.h
index 3802341..6d4e295 100644
--- a/dmucs_db.h
+++ b/dmucs_db.h
@@ -97,13 +97,13 @@ public:
     DmucsHost * getHost(const struct in_addr &ipAddr);
     bool 	haveHost(const struct in_addr &ipAddr);
     unsigned int getBestAvailCpu();
-    void	assignCpuToClient(unsigned int clientIp,
-				  unsigned int cpuIp);
+    void	assignCpuToClient(const unsigned int clientIp,
+				  const unsigned int cpuIp);
     void 	moveCpus(DmucsHost *host, int oldTier, int newTier);
     int 	delCpusFromTier(int tier, unsigned int ipAddr);
 
     void 	addNewHost(DmucsHost *host);
-    void	releaseCpu(intptr_t sock);
+    void	releaseCpu(const unsigned int sock);
 
     void 	addToHostSet(dmucs_host_set_t *theSet, DmucsHost *host);
     void 	delFromHostSet(dmucs_host_set_t *theSet, DmucsHost *host);
@@ -195,9 +195,9 @@ public:
 	}
 	return itr->second.getBestAvailCpu();
     }
-    void assignCpuToClient(unsigned int clientIp,
-                           DmucsDprop dprop,
-                           intptr_t sock);
+    void assignCpuToClient(const unsigned int clientIp,
+                           const DmucsDprop dprop,
+                           const unsigned int sock);
     void moveCpus(DmucsHost *host, int oldTier, int newTier) {
 	MutexMonitor m(&mutex_);
 	// Assume the DmucsDpropDb is definitely there.
@@ -261,7 +261,7 @@ public:
 	return dbDb_.find(host->getDprop())->second.delFromUnavailDb(host);
     }
 
-    void releaseCpu(intptr_t sock);
+    void releaseCpu(const unsigned int sock);
 
     void handleSilentHosts() {
 	MutexMonitor m(&mutex_);
diff --git a/dmucs_hosts_file.cc b/dmucs_hosts_file.cc
index e6af037..a2ea821 100644
--- a/dmucs_hosts_file.cc
+++ b/dmucs_hosts_file.cc
@@ -43,8 +43,8 @@ DmucsHostsFile *DmucsHostsFile::getInstance(const std::string &file)
 
 
 DmucsHostsFile::DmucsHostsFile(const std::string &hostsInfoFile) :
-    hostsInfoFile_(hostsInfoFile),
-    lastFileChangeTime_(0)
+    lastFileChangeTime_(0),
+    hostsInfoFile_(hostsInfoFile)
 {
     readFileIntoDb();
     /* We know the file has changed since time 0 -- so just call this
diff --git a/dmucs_hosts_file.h b/dmucs_hosts_file.h
index d5005d4..9b94166 100644
--- a/dmucs_hosts_file.h
+++ b/dmucs_hosts_file.h
@@ -24,11 +24,11 @@
 #include <map>
 #include <string>
 
-#ifdef SYSCONFDIR
-const std::string HOSTS_INFO_FILE = std::string(SYSCONFDIR) + \
-	std::string("/") + std::string("dmucs.conf");
+#ifdef PKGDATADIR
+const std::string HOSTS_INFO_FILE = std::string(PKGDATADIR) + \
+	std::string("/") + std::string("hosts-info");
 #else
-const std::string HOSTS_INFO_FILE = "dmucs.conf";
+const std::string HOSTS_INFO_FILE = "hosts-info";
 #endif
 
 
diff --git a/dmucs_msg.cc b/dmucs_msg.cc
index d11b3ff..32b1f19 100755
--- a/dmucs_msg.cc
+++ b/dmucs_msg.cc
@@ -97,7 +97,7 @@ DmucsMsg::parseMsg(Socket *sock, const char *buffer)
 		machname, state, dpropstr);
 	struct in_addr host;
 	host.s_addr = inet_addr(machname);
-	host_status_t status = STATUS_UNAVAILABLE;
+	host_status_t status;
 	if (strncmp(state, "up", 2) == 0) {
 	    status = STATUS_AVAILABLE;
 	} else if (strncmp(state, "down", 4) == 0) {
@@ -130,7 +130,7 @@ DmucsHostReqMsg::handle(Socket *sock, const char *buf)
 
 	fprintf(stderr, "Giving out %s\n", resolved_name.c_str());
 
-	db->assignCpuToClient(cpuIpAddr, dprop_, (intptr_t)sock);
+	db->assignCpuToClient(cpuIpAddr, dprop_, (unsigned int) sock);
 #if 0
 	fprintf(stderr, "The databases are now:\n");
 	db->dump();
diff --git a/gethost.cc b/gethost.cc
index 1ec59eb..aabf974 100644
--- a/gethost.cc
+++ b/gethost.cc
@@ -83,14 +83,8 @@ main(int argc, char *argv[])
     std::ostringstream serverName;
     serverName << "@" << SERVER_MACH_NAME;
     int serverPortNum = SERVER_PORT_NUM;
-    const char *distingProp = "";
-
-    const char* env = getenv("DMUCS_SERVER");
-    if (env)
-    {
-        serverName.seekp(1);     // remove everything after the first "@".
-        serverName << env << '\0';
-    }
+    struct hostent *he;
+    char *distingProp = "";
 
     int nextarg = 1;
     for (; nextarg < argc; nextarg++) {
@@ -159,6 +153,7 @@ main(int argc, char *argv[])
 	struct sockaddr sck;
 	socklen_t s = sizeof(sck);
 	getsockname(client_sock->skt, &sck, &s);
+	struct sockaddr_in *sin = (struct sockaddr_in *) &sck;
 
 	std::ostringstream clientReqStr;
 	clientReqStr << "host " << inet_ntoa(in) << " " << distingProp;
diff --git a/loadavg.cc b/loadavg.cc
index 1fe89ec..27e23c3 100644
--- a/loadavg.cc
+++ b/loadavg.cc
@@ -143,7 +143,7 @@ main(int argc, char *argv[])
 	if (fgets(buf, 1024, output) == NULL) {
 	    strcpy(ldStr," 0.0 0.0 0.0");
 	} else {
-	    //char junk1[8];
+	    char junk1[8];
 	    float ldAvg1 = 0.0, ldAvg5 = 0.0, ldAvg10 = 0.0;
 
 	    std::istringstream ist(buf);
diff --git a/main.cc b/main.cc
index 2ecd797..c39fa3c 100644
--- a/main.cc
+++ b/main.cc
@@ -286,7 +286,7 @@ handleReq(Socket *sock_req, DmucsDb *db)
 
     if (Sgets(buf, BUFSIZE, sock_req) == NULL) {
 	DMUCS_DEBUG((stderr, "Socket closed: %s\n", peer2buf(sock_req, buf)));
-	db->releaseCpu((intptr_t)sock_req);
+	db->releaseCpu((unsigned int)sock_req);
 	removeFd(sock_req);
 	return;
     }
diff --git a/monitor.cc b/monitor.cc
index 16d191f..35b9cfb 100644
--- a/monitor.cc
+++ b/monitor.cc
@@ -227,8 +227,7 @@ parseResults(const char *resultStr)
 	    std::string hostname = (he != NULL) ? he->h_name : ipstr;
             /* Remove everything from the first . onward -- so we don't see
                the long domain name in the output. */
-            if (hostname.find_first_of('.') != std::string::npos)
-                hostname.erase(hostname.find_first_of('.'));
+            hostname.erase(hostname.find_first_of('.'));
 
 	    /*
 	     * We collect each hostname based on its state, and add it
@@ -282,8 +281,7 @@ parseResults(const char *resultStr)
                 } else {
                   hname = he->h_name;
                   /* Remove domain name from end of hostname. */
-                  if (hname.find_first_of('.') != std::string::npos)
-                      hname.erase(hname.find_first_of('.'));
+                  hname.erase(hname.find_first_of('.'));
                 }
 		std::ostringstream hostname;
 		hostname << hname;
diff --git a/remhost.cc b/remhost.cc
index d136823..49f69f9 100644
--- a/remhost.cc
+++ b/remhost.cc
@@ -123,10 +123,10 @@ main(int argc, char *argv[])
     struct in_addr in;
     memcpy(&in.s_addr, he->h_addr_list[0], sizeof(in.s_addr));
 
-    /*struct sockaddr sck;
+    struct sockaddr sck;
     socklen_t s = sizeof(sck);
     getsockname(client_sock->skt, &sck, &s);
-    struct sockaddr_in *sin = (struct sockaddr_in *) &sck;*/
+    struct sockaddr_in *sin = (struct sockaddr_in *) &sck;
 
     /* If the name of the program is "addhost", then send "up" to the
        dmucs server.  Otherwise, send "down". */
-- 
1.7.9.5

